
/* fizzbounce
 * 1999 (c) scut / teso
 *
 * main routines
 */

#define	FB_MAIN_C

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "relay.h"
#include "client.h"
#include "main.h"
#include "network.h"

bound	*b;

int
main (int argc, char **argv)
{
	int	n;

	banner ();

	if (argc != 7) {
		usage ();
		exit (1);
	}

/*	if (fork () != 0)
		exit (0);
*/

	b = net_bind (argv[1], atoi(argv[2]));
	if (b == NULL) {
		printf ("cannot bind to %s:%u\n", argv[1], atoi(argv[2]));
		quit();
	}
	printf("bound to %s, port %u\n", argv[1], atoi(argv[2]));

	srv_main (argv[3], argv[4], argv[5], argv[6]);

	/* should never happen */
	return (0);
}

void
srv_main (char *connip, char *connport, char *ircip, char *ircport)
{
	struct sockaddr_in	csa;
	client			*cnew;
	int			cs, n;

	while (1) {
		cs = net_accept (b->bs, &csa, 20);
		if (cs == -1) {
			quit();
		}

		/* if we actually experience a new connection start a new client thread */
		if (cs) {
			cnew = cl_add ();
			if (cnew == NULL) {
				printf ("cannot add new client\n");
			} else {
				pthread_mutex_lock (&cnew->cl_mutex);
				cnew->cs = cs;
				cnew->connip = strdup (connip);
				cnew->connport = atoi (connport);
				cnew->ircip = strdup (ircip);
				cnew->ircport = strdup (ircport);
				memcpy (&cnew->csa, &csa, sizeof (struct sockaddr_in));
				pthread_mutex_unlock (&cnew->cl_mutex);

				n = pthread_create (&cnew->tid, NULL, (void *) cl_handle, (void *) cnew);
				if (n == -1) {
					printf ("cannot create new client thread: %s\n", strerror (errno));
				}
			}
		}
	}

	quit();
}

void
usage (void)
{
	printf("usage: fizzbounce <local-ip | *> <local-port> <squid-proxy>\n             <proxy-port> <irc-host> <irc-port>\n");
	return;
}

void
banner (void)
{
	printf("jizzbounce "VERSION" by "AUTHORS"\n");
	return;
}

void
quit (void)
{
	printf ("shutting fizzbounce down.\n");

	/* terminate main thread */
	exit (0);
}

