/* soxtest - socks tester
 *
 * by scut / teso
 *
 */

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "network.h"

int
usage (char *prgname)
{
	printf ("soxtest - by scut / teso\n\n");
	printf ("usage: %s <ip|host>:<port>\n\n", prgname);
	exit (EXIT_FAILURE);
}

int
main (int argc, char **argv)
{
	bound			*tb;
	int			w, p;
	struct sockaddr_in	cs;
	char			*ip;
	unsigned short int	port;

	if (argc != 2)
		usage (argv[0]);

	if (net_parseip (argv[1], &ip, &port) == 0)
		usage (argv[0]);

	tb = net_bind ("*", 0);
	if (tb == NULL) {
		fprintf (stderr, "binding failed\n");
		exit (1);
	}

	printf ("%s:%hu -C", ip, port);
	fflush (stdout);

	w = net_socks_connect (ip, port, net_getlocalip (), tb->port, 30);
	if (w == -1) {
		exit (0);
	}

	printf ("-A");
	fflush (stdout);

	p = net_accept (tb->bs, &cs, 20);
	if (p <= 0) {
		printf (" FAILED\n");
		exit (0);
	} else {
		printf (" SUCCESS [%s:%hu]\n", inet_ntoa (cs.sin_addr), htons (cs.sin_port));
	}
	close (p);
	close (w);

	return (0);
}

